; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE0A)|(0<<OCIE0B)|(0<<TOIE0)
	sts TIMSK0,temp 
	ldi temp,(0<<ICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)
	sts TIMSK1,temp 
	ldi temp,(0<<OCIE2A)|(0<<OCIE2B)|(1<<TOIE2)
	sts TIMSK2,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Timer1 (16Bit ) initialisieren (Frequenz-Zhler)							
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
; CS12 CS11 CS10 Description												
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
;	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
; 	1 	0 	1 	clkI/O/1024 (From prescaler)								
; *	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
TIMER1_FREQUENZZAEHLER_INITIALISIERUNG:
	ldi temp,(1<<CS12)|(1<<CS11) |(0<<CS10)   
	sts TCCR1B,temp  

	sts TCNT1H,NULL; TIMER1 STARTWERT	(zuerst high)
	sts TCNT1L,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Frequenz-Zhler																
TIM1_OVF:
	in	KOPIE_SREG,SREG		; sichern			
	MOV KOPIE_TEMP,TEMP

	LDS temp,(adr_FREQ_i)	
	inc temp
	STS (adr_FREQ_i),temp
		
	out	SREG,KOPIE_SREG		; wiederherstellen
	mov	TEMP,KOPIE_TEMP	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER2 (8Bit) Vorteiler														
;																				
; TCCR2 ==> FOC2 WGM20 COM21 COM20 WGM21 CS22 CS21 CS20 						
; CS22 CS21 CS20 Description													
;	0	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/		(No prescaling)										
; *	0 	1 	0 	clkT2S/8 	(From prescaler)									
;	0 	1 	1 	clkT2S/32 	(From prescaler)									
; 	1 	0 	0 	clkT2S/64 	(From prescaler)									
;	1 	0 	1 	clkT2S/128 	(From prescaler)									
;	1 	1 	0 	clkT2S/256 	(From prescaler)									
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
TIMER2_100us_INITIALISIERUNG:
	ldi temp,(0<<CS22)|(1<<CS21) |(0<<CS20)  
	sts TCCR2B,temp  
	ldi temp,(256-100)		;(2 hoch 8  minus...)
	mov TIMERWERT2,temp
	sts TCNT2,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM2_OVF:
	sts TCNT2,TIMERWERT2 	; TIMER2 Startwert		
	in	KOPIE_SREG,SREG		; sichern			
	MOV KOPIE_TEMP,TEMP
;-------------------------------------------------------------------------------
	LDS temp,(adr_STOP_UHR_L)
	inc temp
	STS(adr_STOP_UHR_L),temp
	brne TIM2_OVF_w
	LDS temp,(adr_STOP_UHR_H)
	inc temp
	STS(adr_STOP_UHR_H),temp
TIM2_OVF_w:
;-------------------------------------------------------------------------------
; UHR-COUNTER																	
	sub UHR_COUNTER_L,EINS
	sbc UHR_COUNTER_H,NULL
	tst UHR_COUNTER_L                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
	brne TIM2_OVF_UHR_FERTIG
	tst UHR_COUNTER_H
	brne TIM2_OVF_UHR_FERTIG
	ldi temp, low(10000)
	mov UHR_COUNTER_L,temp
	ldi temp,HIGH(10000)
	mov UHR_COUNTER_H,temp
;-------------------------------------------------------------------------------
; Frequenzzhler																
	lds temp,TCNT1L
	STS (adr_FREQ0),temp
	lds temp,TCNT1H
	STS (adr_FREQ1),temp
	LDS temp,(adr_FREQ_i)
	STS (adr_FREQ2),temp

	sts TCNT1H,NULL			; NULL
	sts TCNT1L,NULL			; NULL
	STS (adr_FREQ_i),NULL	; NULL
	rcall UHR
TIM2_OVF_UHR_FERTIG:
;-------------------------------------------------------------------------------


;-------------------------------------------------------------------------------
	out	SREG,KOPIE_SREG		; wiederherstellen
	mov	TEMP,KOPIE_TEMP		
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR:
	LDS temp,(adr_ss)
	inc temp
	cpi temp,60
	brsh UHR_mm
	STS (adr_ss),temp
	ret
;-------------------------------------------------------------------------------
UHR_mm:
	STS (adr_ss),NULL
	LDS temp,(adr_mm)
	inc temp
	cpi temp,60
	brsh UHR_hh
	STS (adr_mm),temp
	ret
;-------------------------------------------------------------------------------
UHR_hh:
	STS (adr_mm),NULL	; in SRAM speichern	
	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	cpi temp,24
	brsh UHR_hh_NULL
	STS (adr_hh),temp	; in SRAM speichern	
	ret
;-------------------------------------------------------------------------------
; TAG																			
UHR_hh_NULL:
	STS (adr_hh),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
